#import <Foundation/Foundation.h>
#import "AsReaderWiredBOXTypeSDKDefine.h"
#import "AsReaderWiredBOXTypeSDKDefine.h"
@class AsWiredBOXPrinter;
@class AsReaderWiredBOXType;

@protocol AsReaderWiredBOXTypeDelegate <NSObject>
@optional
// Common
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType updatedRegistryStatus:(AsReaderWiredBOXTypeSDKBOXStatusCode)statusCode;

// Network
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType networkStateChanged:(AsReaderWiredBOXTypeSDKBOXNetworkState)state error:(NSError *)error;
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType searchingIP:(NSString*)ip isFinish:(BOOL)isFinish;
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType didSetSessionStatus:(AsReaderWiredBOXTypeSDKBOXStatusCode)state;
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType receivedSession:(uint8_t)session;
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType searchedUPDSearchingDeviceInfo:(NSArray *)arrInfos;

// RFID
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType inventoryStartedWithStatus:(AsReaderWiredBOXTypeSDKBOXStatusCode)statusCode;
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType inventoryStoppedWithStatus:(AsReaderWiredBOXTypeSDKBOXStatusCode)statusCode;

- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType receivedPCEPCData:(NSData *)pcEpc selectAntenna:(AsReaderWiredBOXTypeSDKBOXSelectAntenna)antenna;
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType didSetFHLBTStatus:(AsReaderWiredBOXTypeSDKBOXStatusCode)statusCode;
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType receivedFHLBTData:(NSData *)data readTime:(int)readTime idleTime:(int)idleTime;
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType didSetOutputPowerLevelStatus:(AsReaderWiredBOXTypeSDKBOXStatusCode)statusCode;
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType receivedOutputPowerLevel:(uint16_t)powerLevel maxPower:(uint16_t)maxPower minPower:(uint16_t)minPower;

// BARCODE
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType HIDDataRecived:(NSData *)HIDData;
//test
- (void)rxData:(NSData *)data;

- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType readTimeForMultiAntennaReceivedAnt1:(uint16_t)ant1 Ant2:(uint16_t)ant2 Ant3:(uint16_t)ant3 Ant4:(uint16_t)ant4 Ant5:(uint16_t)ant5 Ant6:(uint16_t)ant6 Ant7:(uint16_t)ant7 Ant8:(uint16_t)ant8;
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType receivedOuputPowerAntenna1:(uint16_t)antenna1
               Antenna2:(uint16_t)antenna2
               Antenna3:(uint16_t)antenna3 Antenna4:(uint16_t)antenna4
               Antenna5:(uint16_t)antenna5 Antenna6:(uint16_t)antenna6
               Antenna7:(uint16_t)antenna7 Antenna8:(uint16_t)antenna8
              Min:(uint16_t)min Max:(uint16_t)max;
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType didSetOutputPowerForMultiAntenna:(AsReaderWiredBOXTypeSDKCommonStatus)statusCode;
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType didSetReadTimeForMultiAntenna:(AsReaderWiredBOXTypeSDKCommonStatus)status;
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType
    channelReceived:(uint8_t)channel channelOffset:(uint8_t)channelOffset;
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType didSetChParamReceived:(uint8_t)statusCode;
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType
    hoppingTableReceived:(NSData *)table;
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType
    regionReceived:(uint8_t)region;
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType didSetRegionReceived:(AsReaderWiredBOXTypeSDKBOXStatusCode)statusCode;
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType setRecharging:(AsReaderWiredBOXTypeSDKBOXStatusCode)statusCode;
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType rfidModuleVersionReceived:(NSString *)rfidModuleVersion;
- (void)AsReaderWiredBOXType:(AsReaderWiredBOXType *)AsReaderWiredBOXType receivedRechargedStatus:(AsReaderWiredBOXTypeSDKBOXStatusCode)statusCode;
@end

@interface AsReaderWiredBOXType : NSObject

@property(nonatomic,strong,readonly)NSString * host;

@property(nonatomic, weak)id<AsReaderWiredBOXTypeDelegate>delegate;

@property(nonatomic,assign,readonly)BOOL isConnected;

@property(nonatomic,assign) BOOL isShowPrintNSLog;

@property(nonatomic,assign) AsReaderWiredBOXTypeConnectMethod connectMethod;

+ (AsReaderWiredBOXType *)sharedInstance;
- (AsWiredBOXPrinter *)getAsWiredBOXPrinter;
- (NSString *)getSDKVersion;
// Common
- (BOOL)setSession:(uint8_t)session;
- (BOOL)getSession;
- (BOOL)updateRegistry;

/*UDP*/
-(BOOL)startSearchDevice;
-(BOOL)stopSearchDevice;

/*TCP*/
//-(BOOL) txData:(NSData*)data;
- (BOOL)connectServer:(NSString*)ip port:(int)port;
- (BOOL)disconnectServer;
- (BOOL)startReceiveHIDData;
- (BOOL)stopReceiveHIDData;
- (BOOL)startReceiveRFIDData;
- (BOOL)stopReceiveRFIDData;

// RFID
- (BOOL)stopInventory;
- (AsReaderWiredBOXTypeSDKResultSetRecharging)setRecharging:(BOOL)status;
- (BOOL)getRechargedStatus;
- (BOOL)startInventoryWithTagsMaxTagCount:(uint8_t)maxTagCount
                             readTime:(uint8_t)readTime
                          repeatCycle:(uint16_t)repeatCycle
                        enableAntenna1:(BOOL)antenna1
                        enableAntenna2:(BOOL)antenna2
                        enableAntenna3:(BOOL)antenna3
                        enableAntenna4:(BOOL)antenna4
                        enableAntenna5:(BOOL)antenna5
                        enableAntenna6:(BOOL)antenna6
                        enableAntenna7:(BOOL)antenna7
                        enableAntenna8:(BOOL)antenna8;

- (BOOL)getOutputPowerLevelForMultiAntenna;
- (BOOL)setOutputPowerLevelAntenna1:(uint16_t)powerLevel1
                           Antenna2:(uint16_t)powerLevel2
                           Antenna3:(uint16_t)powerLevel3
                           Antenna4:(uint16_t)powerLevel4
                           Antenna5:(uint16_t)powerLevel5
                           Antenna6:(uint16_t)powerLevel6
                           Antenna7:(uint16_t)powerLevel7
                           Antenna8:(uint16_t)powerLevel8;

- (BOOL)setOutputPowerLevel:(uint16_t)power;
- (BOOL)getOutputPowerLevel;
- (BOOL)getFHLBTParam;
- (BOOL)setFHLBTParamReadTime:(uint16_t)readTime
                     idleTime:(uint16_t)idleTime
             carrierSenseTime:(uint16_t)carrierSenseTime
                      rfLevel:(int)rfLevel
             frequencyHopping:(uint8_t)frequencyHopping
             listenBeforeTalk:(uint8_t)listenBeforeTalk
               continuousWave:(uint8_t)continuousWave;

- (BOOL)setReadTimeForMultiAntennaReceivedAnt1:(uint16_t)ant1 Ant2:(uint16_t)ant2 Ant3:(uint16_t)ant3 Ant4:(uint16_t)ant4 Ant5:(uint16_t)ant5 Ant6:(uint16_t)ant6 Ant7:(uint16_t)ant7 Ant8:(uint16_t)ant8;
- (BOOL)getReadTimeForMultiAntenna;
- (BOOL)setDHCPOnMac:(NSString*)macAddr;
- (BOOL)setDHCPOffMac:(NSString*)macAddr IP:(NSString*)ip Subnet:(NSString*)subnet Gateway:(NSString*)gateway DNSServer:(NSString*)dnsServer;
- (BOOL)getChannel;
- (BOOL)setChannel:(uint8_t)channel
     channelOffset:(uint8_t)channelOffset;
- (BOOL)getFreqHoppingTable;
- (BOOL)getRegion;
- (BOOL)setRegion:(uint8_t)region;
- (BOOL)tX:(NSData *)data;
- (BOOL)getRFIDModuleVersion;
@end


