#import <Foundation/Foundation.h>

@protocol AsReaderWiredBOXTypeWiredBOXDelegate <NSObject>
@optional
- (void)wiredBOXDataRecived:(NSString *)string;
@end


@protocol AsReaderWiredBOXTypePowerDelegate <NSObject>
@optional
- (void)receivedRechargedStatus:(uint8_t)statusCode;
@end

@protocol AsReaderWiredBOXTypeBarcodeDelegate <NSObject>
@optional
- (void)barcodeDataRecived:(NSData *)barcodeData;
@end

@protocol AsReaderWiredBOXTypeRcpRfidDelegate <NSObject>
@optional
- (void)pcEpcReceived:(NSData *)pcEpc;
- (void)pcEpcReceivedMultiAntmode:(NSData *)pcEpc selectAnt:(int)ant;
- (void)epcReceived:(NSData *)epc;
- (void)epcReceived:(NSData *)epc rssi:(int8_t)rssi;
- (void)epcReceived:(NSData *)epc tid:(NSData*)tid;
- (void)pcEpcRssiReceived:(NSData *)pcEpc rssi:(int8_t)rssi;
- (void)pcEpcSensorDataReceived:(NSData *)pcEpc sensorData:(NSData *)sensorData;
- (void)readerConnected:(uint8_t)status;
- (void)readerConnected;
- (void)errReceived:(uint8_t)errCode;
- (void)errDetailReceived:(NSData *)errCode;
- (void)readerInfoReceived:(NSData *)data;
- (void)readerInfoReceivedWithDict:(NSDictionary *)info;
- (void)frequencyHoppingModeReceived:(uint8_t)statusCode;
- (void)regionReceived:(uint8_t)region;
- (void)selectParamReceived:(NSData *)selParam;
- (void)channelReceived:(uint8_t)channel channelOffset:(uint8_t)channelOffset;
- (void)fhLbtReceived:(NSData *)fhLb;
- (void)tagMemoryReceived:(NSData *)data;
- (void)hoppingTableReceived:(NSData *)table;
- (void)anticolParamReceived:(uint8_t)param;
- (void)anticolParamReceived:(uint8_t)mode start:(uint8_t)start max:(uint8_t)max min:(uint8_t)min;
- (void)rssiReceived:(uint16_t)rssi;
- (void)batteryChargeReceived:(int)battery;
- (void)startedReadTags:(uint8_t)statusCode;
- (void)startedReadTagsWithRssi:(uint8_t)statusCode;
- (void)didSetOutputPowerLevel:(uint8_t)status;
- (void)writedReceived:(uint8_t)statusCode;
- (void)stoppedReadTags:(uint8_t)statusCode;
- (void)lockedReceived:(uint8_t)statusCode;
- (void)killedReceived:(uint8_t)statusCode;
- (void)didSetSelParamReceived:(uint8_t)statusCode;
- (void)didSetChParamReceived:(uint8_t)statusCode;
- (void)didSetFhLbtReceived:(uint8_t)statusCode;
- (void)didSetTxPwrReceived:(uint8_t)statusCode;
- (void)didSetHoppintTbleReceived:(uint8_t)statusCode;
- (void)didSetAntiColModeReceived:(uint8_t)statusCode;
- (void)sessionReceived:(uint8_t)session;
- (void)didSetStopConditionMtnu:(uint8_t)statusCode;
- (void)stopConditionReceived:(NSData *)data;
- (void)didSetOptiFreqHPTable:(uint8_t)statusCode;
- (void)didSetFreqHPTable:(uint8_t)statusCode;
- (void)didSetFreqHPMode:(uint8_t)statusCode;
- (void)didSetSession:(uint8_t)statusCode;
- (void)feedbackParamReceived:(uint8_t)lpf res1:(uint8_t)res1 res2:(uint8_t)res2;
- (void)updatedRegistry:(uint8_t)statusCode;
- (void)didSetReportDelayReceived:(uint8_t)statusCode;
- (void)outputPowerLevelReceived:(uint16_t)power max:(uint16_t)maxPower min:(uint16_t)minPower;
- (void)txPowerLevelReceived:(NSData*)power;
- (void)didSetSmartHopping:(uint8_t)statusCode;
- (void)didSetRegionReceived:(uint8_t)statusCode;

/**
 *  @brief      Response of "Get PA GAIN MODE " for RED4S
 *  @details    receive PA GAIN MODE value
 *  @param      isHigh : YES (High Gain) / NO : (Low Gain)
 */
- (void)paGainModeReceived:(BOOL)isHigh;

/**
 *  @brief      Response of "Get RSSI Threshold value" for RED4S
 *  @details    receive RSSI Thres hold value
 *  @param      threshold : value ex)50 =>  -50dBm
 */
- (void)rssiThresholdReceived:(uint16_t)threshold;

- (void)rfidModuleVersionReceived:(NSString *)version;


/*2019-0410 Added by Robin */
- (void)outputPowerForMultiAntennaReceivedAnt1:(uint16_t)ant1
                                          Ant2:(uint16_t)ant2
                                          Ant3:(uint16_t)ant3
                                          Ant4:(uint16_t)ant4
                                          Ant5:(uint16_t)ant5
                                          Ant6:(uint16_t)ant6
                                          Ant7:(uint16_t)ant7
                                          Ant8:(uint16_t)ant8
                                           Min:(uint16_t)min
                                           Max:(uint16_t)max;

- (void)readTimeForMultiAntennaReceivedAnt1:(uint16_t)ant1
                                       Ant2:(uint16_t)ant2
                                       Ant3:(uint16_t)ant3
                                       Ant4:(uint16_t)ant4
                                       Ant5:(uint16_t)ant5
                                       Ant6:(uint16_t)ant6
                                       Ant7:(uint16_t)ant7
                                       Ant8:(uint16_t)ant8;

-(void)didSetPowerForMultiAntenna:(uint8_t)status;
-(void)didSetReadTimeForMultiAntenna:(uint8_t)status;

@end

@interface Parser : NSObject
@property (assign, nonatomic) BOOL firstRead;
- (int) readData:(NSData *) data;
@property (atomic, retain) id <AsReaderWiredBOXTypeRcpRfidDelegate> delegate;
@property (atomic, retain) id <AsReaderWiredBOXTypeBarcodeDelegate> barcodeDelegate;
@property (atomic, retain) id <AsReaderWiredBOXTypeWiredBOXDelegate> wiredBOXDelegate;
@property (atomic, retain) id <AsReaderWiredBOXTypePowerDelegate> powerDelegate;
@end
