#import <Foundation/Foundation.h>

@interface AsReaderWiredBOXTypeRcpRfidApi : NSObject
- (id)init;
- (NSString*)getSDKVersion;
- (NSData *)getRFIDModuleVersion;
- (NSData *)setReaderPower:(BOOL)on;
- (NSData *)setReaderPower:(BOOL)on connectedBeep:(BOOL)connectedBeep;

- (NSData *)setBeep:(uint8_t)beepOn
       setVibration:(uint8_t)vibrationOn
    setIllumination:(uint8_t)illuminationOn;

- (NSData *)startReadTags:(uint8_t)mtnu
                    mtime:(uint8_t)mtime
              repeatCycle:(uint16_t)repeatCycle;
- (NSData *)startReadTagsWithRssi:(uint8_t)mtnu
                            mtime:(uint8_t)mtime
                      repeatCycle:(uint16_t)repeatCycle;
- (NSData *)startReadTagsWithTid:(uint8_t)mtnu
                           mtime:(uint8_t)mtime
                     repeatCycle:(uint16_t)repeatCycle;
- (NSData *)startReadTagsRFM:(uint8_t)codeType
                        mtnu:(uint8_t)mtnu mtime:(uint8_t)mtime
                 repeatCycle:(uint16_t)repeatCycle;
- (NSData *)stopInventory;
- (NSData *)getReaderInfo;
- (NSData *)getReaderInfo:(uint8_t)infoType;
- (NSData *)getRegion;
- (NSData *)setRegion:(uint8_t)region;
- (NSData *)getSelectParam;
- (NSData *)setSelectParam:(uint8_t)target
                    action:(uint8_t)action
                memoryBank:(uint8_t)memoryBank
                   pointer:(uint32_t)pointer
                    length:(uint8_t)length
                  truncate:(uint8_t)truncate
                      mask:(NSData *)mask;
- (NSData *)getChannel;
- (NSData *)setChannel:(uint8_t)channel
         channelOffset:(uint8_t)channelOffset;
- (NSData *)getFhLbtParam;
- (NSData *)setFhLbtParam:(uint16_t)readTime
                 idleTime:(uint16_t)idleTime
         carrierSenseTime:(uint16_t) carrierSenseTime
                  rfLevel:(int)rfLevel
         frequencyHopping:(uint8_t)frequencyHopping
         listenBeforeTalk:(uint8_t)listenBeforeTalk
           continuousWave:(uint8_t)continuousWave;
- (NSData *)getOutputPowerLevel;
- (NSData *)setOutputPowerLevel:(uint16_t)power;
- (NSData *)readFromTagMemory:(uint32_t)accessPassword
                          epc:(NSData*)epc
                   memoryBank:(uint8_t)memoryBank
                 startAddress:(uint16_t)startAddress
                   dataLength:(uint16_t)dataLength;
- (NSData *)getFreqHoppingTable;
- (NSData *)setFreqHoppingTable:(uint8_t)tableSize
                       channels:(NSData*)channels;
- (NSData *)getSession;
- (NSData *)setSession:(uint8_t)session;
- (NSData *)getAnticollision;
- (NSData *)setAnticollision:(uint8_t)mode;
- (NSData *)setAnticollision:(uint8_t)mode
                      qStart:(uint8_t)qStart
                        qMax:(uint8_t)qMax
                        qMin:(uint8_t)qMin;
- (NSData *)setAnticollision:(uint8_t)mode
                      qStart:(uint8_t)qStart
                        qMax:(uint8_t)qMax
                        qMin:(uint8_t)qMin
                       count:(uint8_t)count;
- (NSData *)setReportDelay:(uint8_t)delay;
- (NSData *)writeToTagMemory:(uint32_t)accessPassword
                         epc:(NSData*)epc
                  memoryBank:(uint8_t)memoryBank
                startAddress:(uint16_t)startAddress
                 dataToWrite:(NSData*)dataToWrite;
- (NSData *)killTag:(uint32_t)killPassword
                epc:(NSData*)epc;
- (NSData *)lockTagMemory:(uint32_t)accessPassword
                      epc:(NSData*)epc
                 lockData:(uint32_t)lockData;
- (NSData *)getRssi;
- (NSData *)setStopConditionMtnu:(uint8_t)mtnu
                        setMtime:(uint8_t)mtime
                  setRepeatCycle:(uint16_t)repeatCycle;
-(NSData *)getStopCondition;
- (NSData *)genericTrasport:(uint8_t)TS
                         ap:(uint32_t)accessPassword
                         RM:(uint8_t)RM
                        epc:(NSData*)epc
                        SZ :(uint8_t)SZ
                         GC:(NSData*)GC;
- (NSData *)setGpadc;
- (NSData *)getRssiOffset;
- (NSData *)setRssiOffset;
- (NSData *)setOptimumFrequencyHoppingTable;
- (NSData *) GetFrequencyHoppingMode;
- (NSData *)SetFrequencyHoppingMode:(uint8_t)mode;
- (NSData *)updateRegistry;
- (NSData *)writeToTagMemory:(NSData*)epc
            dataToWriteAscii:(NSString*)dataToWrite;
- (NSData *)writeToTagMemory:(NSData*)epc
              dataToWriteHex:(NSString*)dataToWrite;
- (NSData *) setChargingControl:(BOOL)isOn;
- (NSData *)setRSSIThreshold:(uint16_t)threshold;
- (NSData *)getRSSIThreshold;
- (NSData *)setPAGainMode:(BOOL)isHigh;
- (NSData *)getPAGainMode;
- (NSData *)startMultiReadTags:(uint8_t)mtnu
                         mtime:(uint8_t)mtime
                   repeatCycle:(uint16_t)repeatCycle
                    enableAnt1:(BOOL)ant1
                    enableAnt2:(BOOL)ant2
                    enableAnt3:(BOOL)ant3
                    enableAnt4:(BOOL)ant4
                    enableAnt5:(BOOL)ant5
                    enableAnt6:(BOOL)ant6
                    enableAnt7:(BOOL)ant7
                    enableAnt8:(BOOL)ant8;

/**
 *  @brief     Smart hopping On/Off
 *  @details   Smart hopping On/Off
 *  @return    RCP DATA
 */
-(NSData *)setSmartHoppingOnOff:(BOOL)isOn;

/**
 *  @brief     getSmartHoppingStatus
 *  @details   get Smarthopping On/Off
 *  @return    RCP DATA
 */
- (NSData *)getSmartHoppingOnOff;

- (NSData *)getOutputPowerLevelForMultiAntenna;
- (NSData *)getReadTimeForMultiAntenna;

- (NSData *)setOutputPowerLevelForMultiAntennaAnt1:(uint16_t)ant1
                                              Ant2:(uint16_t)ant2
                                              Ant3:(uint16_t)ant3
                                              Ant4:(uint16_t)ant4
                                              Ant5:(uint16_t)ant5
                                              Ant6:(uint16_t)ant6
                                              Ant7:(uint16_t)ant7
                                              Ant8:(uint16_t)ant8;

- (NSData *)setReadTimeForMultiAntennaAnt1:(uint16_t)ant1
                                      Ant2:(uint16_t)ant2
                                      Ant3:(uint16_t)ant3
                                      Ant4:(uint16_t)ant4
                                      Ant5:(uint16_t)ant5
                                      Ant6:(uint16_t)ant6
                                      Ant7:(uint16_t)ant7
                                      Ant8:(uint16_t)ant8;
@end



