//
//  AsPosPrinter.h
//  AsReaderWiredBOXTypeSDK
//
//  Created by DS.Zhang on 2019/2/20.
//  Copyright © 2019年 Robin. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "AsReaderWiredBOXTypeSDKDefine.h"
#import "AsReaderWiredBOXTypeTCP.h"
#import "AsReaderWiredBOXType.h"

@protocol AsReaderWiredBOXTypePrinterDelegate <NSObject>
@optional
- (void)AsReaderWiredBOXTypePrinterStatus:(AsReaderWiredBOXTypeSDKPrinterStatus)printerStatus;//返回打印机状态目前只有缺纸
- (void)AsReaderWiredBOXTypePrinterConnected:(BOOL)isConnected;//返回打印机连接状态
- (BOOL)retryPrintOnError;//尝试重新打印不清除数据
- (void)whenPrintSuccessed;//打印数据成功
- (void)rxRawData:(NSData *)rxRawData;//接收反馈代理
@end
@interface AsWiredBOXPrinter : NSObject
@property(nonatomic,assign,readonly)BOOL isConnected;
@property (nonatomic, weak) id<AsReaderWiredBOXTypePrinterDelegate> printDelegate;
-(id)initWithAsReaderWiredBOXType:(AsReaderWiredBOXType *)asReaderWiredBOXType;
-(void)getPrinterStatus;
-(void)addPrintText:(NSString*)text
               font:(AsReaderWiredBOXTypeSDKMNPrintFont)font
   printerAlignment:(AsReaderWiredBOXTypeSDKPrinterAlignment)printerAlignment;//添加每一行的打印数据
-(void)addPrintQRCode:(NSString*)qrCode
                 size:(AsReaderWiredBOXTypeSDKQrDotSize)size
     printerAlignment:(AsReaderWiredBOXTypeSDKPrinterAlignment)printerAlignment;//添加要打印QRCode数据
-(void)addPrintImage:(UIImage *)image
               width:(float)width
              height:(float)height
    printerAlignment:(AsReaderWiredBOXTypeSDKPrinterAlignment)printerAlignment;//添加要打印的图片数据
-(void)addCutCommand:(AsReaderWiredBOXTypeSDKCutType)cutType;//添加切纸指令
-(void)openDrawer;//打开钱箱
-(void)cleanPrintData;//清除已添加的数据
-(void)doPrint;//执行打印操作向打印机发送指令

-(void)txRawData:(NSData *)txRawData;//自定义指令添加
@end
